/* Wrap Gladman's code
 */
 
#include "pasis_config.h"
#include "pasis_debug.h"

#include "ed_c_md5.h"
#include "ed_c_md5_rsa.h"


void
ED_C_MD5::digest( const p_byte *buffer,
                  unsigned int length, 
                  p_byte *digest )
{
    MD5_CTX context;
    MD5Init(&context);
    MD5Update(&context, (const char *)buffer, length);
    MD5Final((unsigned int *)digest, &context);
}

void 
ED_C_MD5::digest( const p_byte **buffers,
                  unsigned int *buffer_lengths, 
                  unsigned int num_buffers,
                  p_byte *digest )
{
    MD5_CTX context;
    MD5Init(&context);
    for( unsigned int i = 0; i < num_buffers; ++i ) {
        MD5Update(&context, (const char *)buffers[i], buffer_lengths[i]);
    }
    MD5Final((unsigned int *)digest, &context);
}

void 
ED_C_MD5::key_digest( const p_byte *key,
                      unsigned int key_length,
                      const p_byte *buffer,
                      unsigned int buffer_length, 
                      p_byte *digest )
{
    MD5_CTX context;
    MD5Init(&context);
    MD5Update(&context, (const char *)key, key_length);
    MD5Update(&context, (const char *)buffer, buffer_length);
    MD5Final((unsigned int *)digest, &context);
}


void 
ED_C_MD5::key_digest( const p_byte *key,
                      unsigned int key_length,
                      const p_byte **buffers,
                      unsigned int *buffer_lengths, 
                      unsigned int num_buffers,
                      p_byte *digest )
{
    MD5_CTX context;
    MD5Init(&context);
    MD5Update(&context, (const char *)key, key_length);
    for( unsigned int i = 0; i < num_buffers; ++i ) {
        MD5Update(&context, (const char *)buffers[i], buffer_lengths[i]);
    }
    MD5Final((unsigned int *)digest, &context);
}




