/* cred_cache.h
   cgeisser@andrew.cmu.edu
   based on code by rjs3@andrew.cmu.edu
   
*/

#ifndef CRED_CACHE_H
#define CRED_CACHE_H

#include <time.h>
#include <sys/types.h>

typedef unsigned char byte;

struct hash_entry {
    char *princ;  /* principal */
    u_int client; /* client hostname */
    u_int server; /* server hostname */

    u_int keysize;
    byte *key;

    time_t timestamp;          /* For Timeout Queue */
  
    //struct hash_entry *next_r; /* For return value */
  
    struct hash_entry *next;   /* For Hash Table Chaining */
    struct hash_entry *prev;
    u_int my_code;
  
    struct hash_entry *next_q; /* For Timeout Queue */
    struct hash_entry *prev_q;
};

/* Init the hash subsystem */
void hash_init(void);

/* Hash an item */
void hash_item(char* princ, u_int cli, u_int server, time_t exptime,
	       u_int keysize, byte *key);

/* Returns the next entry that will expire. */
struct hash_entry *hash_nextexp(void);
const int hash_nextexp_time(void);

/* Returns a list of hash_entries (via next_r pointer)
 * which is only good until the next hash_get call */
struct hash_entry *hash_get(char *princ, u_int client, u_int server);
void hash_shutdown(void);

#endif

/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */
