/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASISFS_DATA_H__
#define __PASISFS_DATA_H__

#include "pasis_config.h"

#include "pasisio.h"
#include "pasisio_md_protocol.h"
#include "pasis_md_attr.h"
#include "pasis_md_prot.h"

#include "pasisfs_data_cache.h"

pasis_error_t
PasisFS_FileWrite (pasis_md_fid_t *fid,
                   pasis_md_loc_t *loc,
                   pasis_md_attr_t *attr,
                   unsigned int len,
                   pasisfs_blkaddr_t offset,
                   p_byte *buffer,
                   unsigned int *len_out);


pasis_error_t
PasisFS_FileRead (pasis_md_fid_t  *fid,
                  pasis_md_loc_t  *loc,
                  pasis_md_attr_t *attr,
                  unsigned int len,
                  pasisfs_blkaddr_t offset,
                  p_byte *buffer,
                  unsigned int *len_out);


#endif /* __PASISFS_DATA_H__ */
