/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASISFS_IO_H__
#define __PASISFS_IO_H__

#include "pasis_config.h"

#include "pasisio.h"
#include "pasisio_md_protocol.h"
#include "pasis_md_prot.h"

#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif

pasis_error_t PasisFS_IOInit (int store_data_locally_flag, int store_data_using_qu);

void PasisFS_IOShutdown (void);

/* Inode contains FID, attributes, current uid, and loc_t metadata */
pasis_error_t PasisFS_IORead (pasis_md_fid_t  *fid,
                              pasis_md_loc_t  *loc,
                              p_uint64         blkno,
                              p_byte          *buffer);

pasis_error_t PasisFS_IOWrite (pasis_md_fid_t  *fid,
                               pasis_md_loc_t  *loc,
                               p_uint64         blkno,
                               p_byte          *buffer);

#ifdef __cplusplus
}
#endif


#endif /* __PASISFS_IO_H__ */

/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */ 
