/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#include <map>

using namespace std;

#include "nfs_xact_cache.h"

typedef map <rpc_act_entry_t, bool> rpc_map_t;

rpc_map_t rpc_map;

static inline bool
operator<(const rpc_act_entry_t &a,
          const rpc_act_entry_t &b) {
    return (memcmp(&a, &b, sizeof(rpc_act_entry_t)) < 0);
};

static inline bool
operator==(const rpc_act_entry_t &a,
           const rpc_act_entry_t &b) {
    return (memcmp(&a, &b, sizeof(rpc_act_entry_t)) == 0);
};

void
NFSXactCacheInsert (rpc_act_entry_t *entry)
{
    rpc_map.insert (rpc_map_t::value_type(*entry, true));
}

int
NFSXactCacheLookup (rpc_act_entry_t *entry)
{
    if (rpc_map.find (*entry) == rpc_map.end ()) {
        return 0;
    }
    
    return 1;
}

void
NFSXactCacheRemove (rpc_act_entry_t *entry)
{
    rpc_map.erase (*entry);
}



/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */
