/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASIS_MD_OP_ERR_H__
#define __PASIS_MD_OP_ERR_H__

/* Operation errors: they match NFSv2 and NFSv3 error codes exactly */

enum op_err {
        OP_OK = 0,
        OPERR_PERM = 1,
        OPERR_NOENT = 2,
        OPERR_IO = 5,
        OPERR_NXIO = 6,
        OPERR_ACCES = 13,
        OPERR_EXIST = 17,
        OPERR_NODEV = 19,
        OPERR_NOTDIR = 20,
        OPERR_ISDIR = 21,
        OPERR_INVAL = 22,
        OPERR_FBIG = 27,
        OPERR_NOSPC = 28,
        OPERR_ROFS = 30,
        OPERR_NAMETOOLONG = 63,
        OPERR_NOTEMPTY = 66,
        OPERR_DQUOT = 69,
        OPERR_STALE = 70,
        OPERR_WFLUSH = 99,
        OPERR_BADHANDLE = 10001,
        OPERR_NOT_SYNC = 10002,
        OPERR_BAD_COOKIE = 10003,
        OPERR_NOTSUPP = 10004,
        OPERR_TOOSMALL = 10005,
        OPERR_SERVERFAULT = 10006,
        OPERR_BADTYPE = 10007,
        OPERR_JUKEBOX = 10008,

};


#endif /* __PASIS_MD_OP_ERR_H__ */
