/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASIS_MD_LOG_H__
#define __PASIS_MD_LOG_H__

#include "pasis_config.h"
#include "pasis_types.h"
#include "pasis_md_prot.h"

#include <stdarg.h>


#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif


extern int log_key;

typedef struct pasis_md_log_s {
    unsigned int  op_id;
    FILE         *file;
} pasis_md_log_t;


pasis_error_t pasis_md_log_init (p_uint32 node_id);

void pasis_md_log_shutdown (void);

void pasis_md_log_msg (const char *fmt, ...);

void pasis_md_log_matrices (pasis_md_hist_matrix_t *matrix, 
                            unsigned int num);

void
pasis_md_log_vectors (pasis_md_hist_vector_t *vec,
                      unsigned int num);



#ifdef __cplusplus
}
#endif

#endif
