/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASIS_MD_S4_H__
#define __PASIS_MD_S4_H__

#include "rpc_common.h"

#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif

#define PASIS_MD_TIME_DRIFT 3   /* Allowable clock drift in seconds */

#define PASIS_MD_WORKERS   96                       /* FE worker threads */

#define PASIS_MD_IPC_OPS   (PASIS_MD_WORKERS + 16)  /* Outstanding ipcs */
#define PASIS_MD_IPC_VER   1

#define SHM_BUFSIZE           RPC_MAX_PAYLOAD /* Match with RPC_MAX_PAYLOAD */
#define SHM_ARGSIZE           2048


#define SHARE_VERIFY_MAGIC(share) \
  (share[1] == ED_SECOND_SHARE_BYTE && share[2] == ED_THIRD_SHARE_BYTE && share[3] == ED_FOURTH_SHARE_BYTE)

#ifndef MAX
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#endif

#ifndef MIN
#define MIN(a,b) (((a) < (b)) ? (a) : (b))
#endif

#ifdef __cplusplus
}
#endif

#endif /* __PASIS_MD_S4_H__ */

/*
 * Local variables:
 *  c-basic-offset: 4
 *  indent-tabs-mode: nil
 * End:
 */ 

