/*
 * The PASIS Query/Update Project
 * Copyright (c) 2007, Carnegie Mellon University.
 * All rights reserved.
 * http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 */

#ifndef __PASIS_MD_STATISTICS_H__
#define __PASIS_MD_STATISTICS_H__

#include "pasis_config.h"
#include "pasis_types.h"
#include "pasis_md_prot.h"

#include <stdarg.h>


#ifdef __cplusplus
extern "C" {
#endif
#if 0
}
#endif


/* To do:
 * -As with pasis_md_object_sync.c, pass distribution to init function here.
 * -Look at above file for how to use client code to communicate with other
 *  servers. Things are simpler in pasisio_md_protocol since we don't have to
 *  vote.  I should add a function there to retrieve the statistics from a
 *  quorum of servers.  Again, see object_sync.
 *
 */


pasis_error_t pasis_md_stats_init(p_uint32 num_buckets,
                                  p_uint32 bucket_size); /* in ms */

void pasis_md_stats_shutdown(void);


/* Called whenever a request is initiated */
void pasis_md_stats_callback(void);

/* Called whenever we get an RPC request for the current statistics */
void pasis_md_stats_get(pasis_md_read_op_args_t *args,
                        pasis_md_read_op_res_t  *res);


pasis_md_get_stats_args_t      get_stats;






#ifdef __cplusplus
}
#endif

#endif
