#!/usr/bin/perl

# The PASIS Query/Update Project
# Copyright (c) 2007, Carnegie Mellon University.
# All rights reserved.
# http://www.pdl.cmu.edu/  (Parallel Data Lab at Carnegie Mellon)
#
# This software is being provided by the copyright holders under the
# following license. By obtaining, using and/or copying this software,
# you agree that you have read, understood, and will comply with the
# following terms and conditions:
#
# Permission to reproduce, use, and prepare derivative works of this
# software is granted provided the copyright and "No Warranty" statements
# are included with all reproductions and derivative works and associated
# documentation. This software may also be redistributed without charge
# provided that the copyright and "No Warranty" statements are included
# in all redistributions.
#
# NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
# CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
# EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
# TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
# OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
# MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
# TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
# COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
# OR DOCUMENTATION.

# Run response time experiments with contention.  The "num_contention" array 
# contains a set of different "contention" parameters, where each one specifies 
# the number of clients sharing the same client id (and hence using the same 
# objects).

$METADATA_CONFIG="/h/mabdelm/pasis/experiments/sosp05-final/concurrency/pasis_md_fe.cfg";
$CONTROLLER_CONFIG="/h/mabdelm/pasis/src/tools/scripts/cw_controller-response-time.config";
$CLIENT_READ_COMMAND="/h/mabdelm/pasis-optimized/src/benchmarks/pasisio_md_bench -c CLIENTID /h/mabdelm/pasis/experiments/sosp05-final/concurrency/pasisio_md_bench.config.reader";

$num_runs = 1;
@num_contention = (0);


foreach $i (@num_contention) {
    for (my $j = 1; $j <= $num_runs; $j++) {

        $experiment_name = "$i-contention-run-$j";
        print "Running experiment $experiment_name\n";

        `./cw_controller.pl -n $experiment_name -m $METADATA_CONFIG -c $CONTROLLER_CONFIG -w $i -r "$CLIENT_READ_COMMAND" -e`;
        }
}
